VirtualBox

source: vbox/trunk/configure@ 11538

Last change on this file since 11538 was 11454, checked in by vboxsync, 16 years ago

small fix

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 49.9 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2007 Sun Microsystems, Inc.
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License as published by the Free Software Foundation,
12# in version 2 as it comes in the "COPYING" file of the VirtualBox OSE
13# distribution. VirtualBox OSE is distributed in the hope that it will
14# be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26#
27# Defaults
28#
29OSE=1
30ODIR="`pwd`/"
31SETUP_WINE=
32TARGET_MACHINE=""
33TARGET_CPU=""
34WITH_XPCOM=1
35WITH_LIBIDL=1
36WITH_QT3=1
37WITH_QT4=1
38WITH_SDL=1
39WITH_SDL_TTF=1
40WITH_X11=1
41WITH_ALSA=1
42WITH_PULSE=1
43WITH_KMODS=1
44CC="gcc"
45CC_COMPAT=""
46CC32=""
47CC64=""
48CXX="g++"
49CXX32=""
50CXX64=""
51BCC="bcc"
52YASM="yasm"
53IASL="iasl"
54AS86="as86"
55XSLTPROC="xsltproc"
56GENISOIMAGE="genisoimage"
57MKISOFS="mkisofs"
58BUILD_LIBXML2=
59BUILD_LIBXSLT=
60LIBCRYPTO="-lcrypto"
61LIBPTHREAD="-lpthread"
62LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
63INCX11="/usr/local/include"
64LIBXCURSOR="-lXcursor"
65INCZ=""
66LIBZ="-lz"
67INCPNG=""
68LIBPNG="-lpng"
69QT3DIR="/usr/qt/3 /usr/lib/qt3 /usr/lib/qt-3.3 /usr/share/qt3 /usr/lib64/qt-3.3 /usr/X11R6 /usr/lib/qt"
70QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr"
71QT4DIR_PKGCONFIG=1
72QT4UIC3DIR="/usr/bin"
73KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
74DEVDIR="`cd \`dirname $0\`; pwd`/tools"
75if [ -d "/lib/modules/`uname -r`/build" ]; then
76 LINUX="/lib/modules/`uname -r`/build"
77else
78 LINUX="/usr/src/linux"
79fi
80KCHMVIEWER="kchmviewer"
81LOG="configure.log"
82CNF="AutoConfig.kmk"
83ENV="env.sh"
84BUILD_TYPE="release"
85# the restricting tool is ar (mri mode).
86INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
87
88if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
89 echo "Error: VBox base path contains invalid characters!"
90 exit 1
91fi
92
93# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
94if [ "`uname`" = "Darwin" ]; then
95 ECHO_N="/bin/echo -n"
96else
97 ECHO_N="echo -n"
98fi
99
100
101cleanup()
102{
103 rm -f .tmp_src.cc .tmp_src.c .tmp_out .test_execute.log
104}
105
106fail()
107{
108 if [ -z "$nofatal" -o "x$1" != "x" ]; then
109 cleanup
110 rm -f $ENV
111 exit 1
112 fi
113}
114
115log()
116{
117 echo "$1"
118 echo "$1" >> $LOG
119}
120
121log_success()
122{
123 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
124 echo "OK."
125 echo "$1" >> $LOG
126 echo >> $LOG
127 echo >> $LOG
128}
129
130log_failure()
131{
132 echo
133 echo " ** $1!"
134 echo "** $1!" >> $LOG
135 echo >> $LOG
136}
137
138cnf_append()
139{
140 printf "%-30s := %s\n" "$1" "$2" >> $CNF
141}
142
143strip_l()
144{
145 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
146}
147
148strip_L()
149{
150 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
151}
152
153strip_I()
154{
155 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
156}
157
158prefix_I()
159{
160 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
161}
162
163# Wrapper for ancient /usr/bin/which on darwin that always returns 0
164which_wrapper()
165{
166 if [ -z "$have_ancient_which" ]; then
167 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
168 have_ancient_which="yes"
169 else
170 have_ancient_which="no"
171 fi
172 fi
173 if [ "$have_ancient_which" = "yes" ]; then
174 retval=`which $* 2>/dev/null`
175 echo "$retval"
176 test -n "$retval" -a -x "$retval"
177 unset retval
178 else
179 which $* 2> /dev/null
180 fi
181}
182
183check_avail()
184{
185 if [ -z "$1" ]; then
186 log_failure "$2 is empty"
187 fail $3
188 return 1
189 elif which_wrapper $1 > /dev/null; then
190 return 0
191 else
192 log_failure "$1 (variable $2) not found"
193 fail $3
194 return 1
195 fi
196}
197
198# Prepare a test
199test_header()
200{
201 echo "***** Checking $1 *****" >> $LOG
202 $ECHO_N "Checking for $1: "
203}
204
205# Compile a test
206test_compile()
207{
208 echo "compiling the following source file:" >> $LOG
209 cat .tmp_src.cc >> $LOG
210 echo "using the following command line:" >> $LOG
211 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc \"$1\"" >> $LOG
212 $CXX -O -Wall -o .tmp_out .tmp_src.cc $1 >> $LOG 2>&1
213 if [ $? -ne 0 ]; then
214 if [ -z "$4" ]; then
215 echo
216 echo " $2 not found at $1 or $3 headers not found"
217 echo " Check the file $LOG for detailed error information."
218 fail
219 else
220 echo "not found."
221 echo >> $LOG
222 echo >> $LOG
223 fi
224 return 1
225 fi
226 return 0
227}
228
229# Execute a compiled test binary
230test_execute()
231{
232 echo "executing the binary" >> $LOG
233 ./.tmp_out > .test_execute.log
234 rc=$?
235 cat .test_execute.log | tee -a $LOG
236 if [ $rc -ne 0 ]; then
237 fail $1
238 return 1
239 fi
240 echo >> $LOG
241 echo >> $LOG
242 return 0
243}
244
245# Execute a compiled test binary
246test_execute_path()
247{
248 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
249 LD_LIBRARY_PATH=$1 ./.tmp_out > .test_execute.log
250 rc=$?
251 cat .test_execute.log | tee -a $LOG
252 if [ $rc -ne 0 ]; then
253 fail
254 return 1
255 fi
256 echo >> $LOG
257 echo >> $LOG
258 return 0
259}
260
261#
262# Check for OS, MACHINE, CPU
263#
264check_environment()
265{
266 test_header environment
267 OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
268 case "$OS" in
269 linux)
270 ;;
271 darwin)
272 ;;
273 freebsd)
274 ;;
275 sunos)
276 OS='solaris'
277 ;;
278 *)
279 log_failure "Cannot determine OS"
280 exit 1
281 ;;
282 esac
283 BUILD_CPU=`uname -m`
284 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
285 case "$BUILD_CPU" in
286 i[3456789]86|x86|i86pc)
287 BUILD_MACHINE='x86'
288 LIB='lib'
289 ;;
290 x86_64|amd64)
291 BUILD_MACHINE='amd64'
292 BUILD_CPU='k8'
293 if [ "$OS" != "solaris" ]; then
294 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
295 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
296 LIB='lib64'
297 else
298 # Solaris doesn't seem to subscribe to fhs, libs are usually in
299 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
300 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
301 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
302 # have to make sure the */bin/amd64 dirs are searched before the */bin
303 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
304 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
305 echo "old PATH: $PATH" >> $LOG
306 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
307 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
308 export PATH
309 echo "new PATH: $PATH" >> $LOG
310 LIB='lib/64'
311 fi
312 ;;
313 *)
314 log_failure "Cannot determine system"
315 exit 1
316 ;;
317 esac
318 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
319 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
320 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
321 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
322
323 echo "export BUILD_PLATFORM=\"$OS\"" >> $ENV
324 echo "export BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
325 echo "export BUILD_TARGET=\"$OS\"" >> $ENV
326 echo "export BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
327 echo "export BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
328 echo "export BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
329}
330
331#
332# Check for gcc with version >= 3.2.
333# We depend on a working gcc, if we fail terminate in every case.
334#
335check_gcc()
336{
337 test_header gcc
338 if [ -n "$CC_COMPAT" ]; then
339 if check_avail "$CC_COMPAT" CC_COMPAT really; then
340 cc_compat_ver=`$CC_COMPAT -dumpversion` 2>/dev/null
341 if [ $? -ne 0 ]; then
342 log_failure "cannot execute '$CC_COMPAT -dumpversion'"
343 fail really
344 fi
345 cc_compat_maj=`echo $cc_compat_ver|cut -d. -f1`
346 cc_compat_min=`echo $cc_compat_ver|cut -d. -f2`
347 if [ $cc_compat_maj -lt 3 \
348 -o \( $cc_compat_maj -eq 3 -a $cc_compat_min -lt 2 \) \
349 -o \( $cc_compat_maj -eq 4 -a $cc_compat_min -lt 1 \) \
350 -o \( $cc_compat_maj -eq 4 -a $cc_compat_min -gt 2 \) \
351 -o $cc_compat_maj -gt 4 ]; then
352 log ""
353 log " ** Version $cc_compat_ver of the compatibility gcc found. Expected gcc 3.x with x>1"
354 log " ** or gcc 4.x with 0<x<3"
355 fail really
356 fi
357 cnf_append "VBOX_RECOMPILER_OP_GCC" "$CC_COMPAT"
358 fi
359 fi
360 if check_avail "$CC" CC really; then
361 cc_ver=`$CC -dumpversion` 2>/dev/null
362 if [ $? -ne 0 ]; then
363 log_failure "cannot execute '$CC -dumpversion'"
364 fail really
365 fi
366 if check_avail "$CXX" CXX really; then
367 cxx_ver=`$CXX -dumpversion` 2>/dev/null
368 if [ $? -ne 0 ]; then
369 log_failure "cannot execute '$CXX -dumpversion'"
370 fail really
371 fi
372 cc_maj=`echo $cc_ver|cut -d. -f1`
373 cc_min=`echo $cc_ver|cut -d. -f2`
374 if [ "x$cc_ver" != "x$cxx_ver" ]; then
375 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
376 fail really
377 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "OS" = "darwin" ]; then
378 log_success "found version $cc_ver"
379 elif [ $cc_maj -eq 4 -a $cc_min -eq 3 ]; then
380 if [ -z "$CC_COMPAT" ]; then
381 log ""
382 log " ** There are known problems with gcc version 4.3 when compiling the recompiler"
383 log " ** stuff. You need to specify a compatibility compiler with version < 4.3. Look"
384 log " ** for a package compat-gcc-34 on Fedora systems or something similar on other"
385 log " ** distributions and call configure with parameter --with-gcc-compat=gcc34."
386 fail really
387 fi
388 log_success "found version $cc_ver + compat version $cc_compat_ver"
389 # gcc-4.0 is allowed for Darwin only
390 elif [ $cc_maj -lt 3 \
391 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
392 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
393 -o \( $cc_maj -eq 4 -a $cc_min -gt 3 \) \
394 -o $cc_maj -gt 4 ]; then
395 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<4"
396 fail really
397 else
398 log_success "found version $cc_ver"
399 fi
400 if [ "$BUILD_MACHINE" = "amd64" ]; then
401 [ -z "$CC32" ] && CC32="$CC -m32"
402 [ -z "$CXX32" ] && CXX32="$CXX -m32"
403 else
404 [ -z "$CC32" ] && CC32="$CC"
405 [ -z "$CXX32" ] && CXX32="$CXX"
406 fi
407 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
408 [ -z "$CC64" ] && CC64="$CC -m64"
409 [ -z "$CXX64" ] && CXX64="$CXX -m64"
410 fi
411 if [ "$CC" != "gcc" ]; then
412 cnf_append "TOOL_GCC3_CC" "$CC"
413 cnf_append "TOOL_GCC3_AS" "$CC"
414 cnf_append "TOOL_GCC3_LD" "$CC"
415 cnf_append "TOOL_GXX3_CC" "$CC"
416 cnf_append "TOOL_GXX3_AS" "$CC"
417 fi
418 if [ "$CXX" != "g++" ]; then
419 cnf_append "TOOL_GCC3_CXX" "$CXX"
420 cnf_append "TOOL_GXX3_CXX" "$CXX"
421 cnf_append "TOOL_GXX3_LD" "$CXX"
422 fi
423 if [ "$CC32" != "gcc -m32" ]; then
424 cnf_append "TOOL_GCC32_CC" "$CC32"
425 cnf_append "TOOL_GCC32_AS" "$CC32"
426 cnf_append "TOOL_GCC32_LD" "$CC32"
427 cnf_append "TOOL_GXX32_CC" "$CC32"
428 cnf_append "TOOL_GXX32_AS" "$CC32"
429 fi
430 if [ "$CXX32" != "g++ -m32" ]; then
431 cnf_append "TOOL_GCC32_CXX" "$CXX32"
432 cnf_append "TOOL_GXX32_CXX" "$CXX32"
433 cnf_append "TOOL_GXX32_LD" "$CXX32"
434 fi
435 # this isn't not necessary, there is not such tool.
436 if [ -n "$CC64" ]; then
437 cnf_append "TOOL_GCC64_CC" "$CC64"
438 cnf_append "TOOL_GCC64_AS" "$CC64"
439 cnf_append "TOOL_GCC64_LD" "$CC64"
440 cnf_append "TOOL_GXX64_CC" "$CC64"
441 cnf_append "TOOL_GXX64_AS" "$CC64"
442 fi
443 if [ -n "$CXX64" ]; then
444 cnf_append "TOOL_GCC64_CXX" "$CXX64"
445 cnf_append "TOOL_GXX64_CXX" "$CXX64"
446 cnf_append "TOOL_GXX64_LD" "$CXX64"
447 fi
448 # Solaris sports a 32-bit gcc/g++.
449 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
450 [ "$CC" = "gcc" ] && CC="gcc -m64"
451 [ "$CXX" = "g++" ] && CXX="g++ -m64"
452 fi
453 fi
454 fi
455}
456
457#
458# Check for the bcc compiler, needed for compiling the BIOS
459#
460check_bcc()
461{
462 test_header bcc
463 if check_avail "$BCC" BCC; then
464 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
465 if [ $? -ne 0 ]; then
466 log_failure "not found"
467 fail
468 else
469 echo "compiling the following source file:" >> $LOG
470 cat > .tmp_src.c << EOF
471int foo(a)
472 int a;
473{
474 return 0;
475}
476EOF
477 cat .tmp_src.c >> $LOG
478 bcc_path=`which_wrapper $BCC`
479 bcc_dir="`dirname $bcc_path`/"
480 echo "using the following command line:" >> $LOG
481 echo "$BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c" >> $LOG
482 $BCC -B $bcc_dir -C-c -3 -S -o .tmp_out .tmp_src.c >> $LOG 2>&1
483 if [ $? -ne 0 ]; then
484 log_failure "not found"
485 fail
486 else
487 log_success "found version $bcc_ver"
488 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
489 fi
490 unset bcc_path
491 unset bcc_dir
492 fi
493 fi
494}
495
496#
497# Check for the as86 assembler, needed for compiling the BIOS
498#
499check_as86()
500{
501 test_header as86
502 if check_avail "$AS86" AS86; then
503 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
504 if [ $? -ne 0 ]; then
505 log_failure "not found"
506 fail
507 else
508 log_success "found version $as86_ver"
509 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
510 fi
511 fi
512}
513
514#
515# Check for yasm, needed to compile assembler files
516#
517check_yasm()
518{
519 test_header yasm
520 if check_avail "$YASM" YASM; then
521 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
522 if [ $? -ne 0 ]; then
523 log_failure "not found"
524 fail
525 else
526 yasm_maj=`echo $yasm_ver|cut -d. -f1`
527 yasm_min=`echo $yasm_ver|cut -d. -f2`
528 yasm_rev=`echo $yasm_ver|cut -d. -f3`
529 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
530 if [ $yasm_ver_mul -lt 501 ]; then
531 log_failure "found version $yasm_ver, expected at least 0.5.1"
532 fail
533 else
534 log_success "found version $yasm_ver"
535 fi
536 fi
537 fi
538}
539
540#
541# Check for the iasl ACPI compiler, needed to compile vbox.dsl
542#
543check_iasl()
544{
545 test_header iasl
546 if check_avail "$IASL" IASL; then
547 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
548 if [ $? -ne 0 ]; then
549 log_failure "not found"
550 fail
551 else
552 log_success "found version $iasl_ver"
553 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
554 fi
555 fi
556}
557
558#
559# Check for xsltproc, needed by Main
560#
561check_xsltproc()
562{
563 test_header xslt
564 if check_avail "$XSLTPROC" XSLTPROC; then
565 xsltproc_ver=`$XSLTPROC --version`
566 if [ $? -ne 0 ]; then
567 log_failure "not found"
568 fail
569 else
570 log_success "found"
571 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
572 fi
573 fi
574}
575
576#
577# Check for mkisofs, needed to build the CDROM image containing the additions
578#
579check_mkisofs()
580{
581 test_header mkisofs
582 if which_wrapper $GENISOIMAGE > /dev/null; then
583 mkisofs_ver=`$GENISOIMAGE --version`
584 if [ $? -ne 0 ]; then
585 log_failure "not found"
586 fail
587 else
588 log_success "found $mkisofs_ver"
589 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
590 fi
591 elif check_avail "$MKISOFS" MKISOFS; then
592 mkisofs_ver=`$MKISOFS --version`
593 if [ $? -ne 0 ]; then
594 log_failure "not found"
595 fail
596 else
597 log_success "found $mkisofs_ver"
598 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
599 fi
600 fi
601}
602
603#
604# Check for libxml2, needed by VBoxSettings
605# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
606#
607check_libxml2()
608{
609 if [ -z "$BUILD_LIBXML2" ]; then
610 test_header libxml2
611 if which_wrapper pkg-config > /dev/null; then
612 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
613 if [ $? -ne 0 ]; then
614 log_failure "not found"
615 fail
616 else
617 FLGXML2=`pkg-config libxml-2.0 --cflags`
618 INCXML2=`strip_I "$FLGXML2"`
619 LIBXML2=`pkg-config libxml-2.0 --libs`
620 cat > .tmp_src.cc << EOF
621#include <cstdio>
622#include <libxml/xmlversion.h>
623extern "C" int main(void)
624{
625 printf("found version %s", LIBXML_DOTTED_VERSION);
626#if LIBXML_VERSION >= 20626
627 printf(", OK.\n");
628 return 0;
629#else
630 printf(", expected version 2.6.26 or higher\n");
631 return 1;
632#endif
633}
634EOF
635 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
636 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
637 if test_execute; then
638 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
639 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
640 fi
641 fi
642 fi
643 elif which_wrapper xml2-config; then
644 libxml2_ver=`xml2-config --version`
645 if [ $? -ne 0 ]; then
646 log_failure "not found"
647 fail
648 else
649 log_success "found version $libxml2_ver"
650 FLGXML2=`xml2-config --cflags`
651 INCXML2=`strip_I "$FLGXML2"`
652 LIBXML2=`xml2-config --libs`
653 cat > .tmp_src.cc << EOF
654#include <cstdio>
655#include <libxml/xmlversion.h>
656extern "C" int main(void)
657{
658 printf("found version %s", LIBXML_DOTTED_VERSION);
659#if LIBXML_VERSION >= 20626
660 printf(", OK.\n");
661 return 0;
662#else
663 printf(", expected version 2.6.26 or higher\n");
664 return 1;
665#endif
666}
667EOF
668 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
669 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
670 if test_execute; then
671 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
672 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
673 fi
674 fi
675 fi
676 else
677 log_failure "neither pkg-config nor xml2-config found"
678 fail
679 fi
680 fi
681}
682
683#
684# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.17.
685# This library is available on Ubuntu Edgy which fulfils the minimal libxml2
686# requirement (2.6.26).
687#
688check_libxslt()
689{
690 if [ -z "$BUILD_LIBXSLT" ]; then
691 test_header libxslt
692 if which_wrapper pkg-config > /dev/null; then
693 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
694 if [ $? -ne 0 ]; then
695 log_failure "not found"
696 fail
697 else
698 FLGXSLT=`pkg-config libxslt --cflags`
699 INCXSLT=`strip_I "$FLGXSLT"`
700 LIBXSLT=`pkg-config libxslt --libs`
701 cat > .tmp_src.cc << EOF
702#include <cstdio>
703#include <libxslt/xsltconfig.h>
704extern "C" int main(void)
705{
706 printf("found version %s", LIBXSLT_DOTTED_VERSION);
707#if LIBXSLT_VERSION >= 10117
708 printf(", OK.\n");
709 return 0;
710#else
711 printf(", expected version 1.1.17 or higher\n");
712 return 1;
713#endif
714}
715EOF
716 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
717 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
718 if test_execute; then
719 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
720 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
721 fi
722 fi
723 fi
724 elif which_wrapper xslt-config; then
725 libxslt_ver=`xslt-config --version`
726 if [ $? -ne 0 ]; then
727 log_failure "not found"
728 fail
729 else
730 log_success "found version $libxslt_ver"
731 FLGXSLT=`xslt-config --cflags`
732 INCXSLT=`strip_I "$FLGXSLT"`
733 LIBXSLT=`xslt-config --libs`
734 cat > .tmp_src.cc << EOF
735#include <cstdio>
736#include <libxslt/xsltconfig.h>
737extern "C" int main(void)
738{
739 printf("found version %s", LIBXSLT_DOTTED_VERSION);
740#if LIBXSLT_VERSION >= 10117
741 printf(", OK.\n");
742 return 0;
743#else
744 printf(", expected version 1.1.17 or higher\n");
745 return 1;
746#endif
747}
748EOF
749 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
750 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
751 if test_execute; then
752 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
753 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
754 fi
755 fi
756 fi
757 else
758 log_failure "neither pkg-config nor xslt-config found"
759 fail
760 fi
761 fi
762}
763
764#
765# Check for libIDL, needed by xpcom
766#
767check_libidl()
768{
769 test_header libIDL
770
771 if which_wrapper libIDL-config-2 > /dev/null; then
772 libidl_ver=`libIDL-config-2 --version`
773 if [ $? -ne 0 ]; then
774 log_failure "not found"
775 fail
776 else
777 log_success "found version $libidl_ver"
778 cnf_append "VBOX_LIBIDL_CONFIG" \
779 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
780 fi
781 elif check_avail "libIDL-config" libIDL-config; then
782 libidl_ver=`libIDL-config --version`
783 if [ $? -ne 0 ]; then
784 log_failure "not found"
785 fail
786 else
787 log_success "found version $libidl_ver"
788 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
789 fi
790 fi
791}
792
793#
794# Check for openssl, needed for RDP
795#
796check_ssl()
797{
798 test_header ssl
799 cat > .tmp_src.cc << EOF
800#include <cstdio>
801#include <openssl/opensslv.h>
802extern "C" int main(void)
803{
804 printf("found version %s", OPENSSL_VERSION_TEXT);
805#if OPENSSL_VERSION_NUMBER >= 0x0090700
806 printf(", OK.\n");
807 return 0;
808#else
809 printf(", expected version 0.9.7 or higher\n");
810 return 1;
811#endif
812}
813EOF
814 if test_compile $LIBCRYPTO libcrypto openssl; then
815 if test_execute nofatal; then
816 cnf_append "SDK_VBOX_OPENSSL_INCS" ""
817 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
818 fi
819 fi
820}
821
822#
823# Check for pthread, needed by VBoxSVC, frontends, ...
824#
825check_pthread()
826{
827 test_header pthread
828 cat > .tmp_src.cc << EOF
829#include <cstdio>
830#include <pthread.h>
831extern "C" int main(void)
832{
833 pthread_mutex_t mutex;
834 if (pthread_mutex_init(&mutex, NULL)) {
835 printf("pthread_mutex_init() failed\n");
836 return 1;
837 }
838 if (pthread_mutex_lock(&mutex)) {
839 printf("pthread_mutex_lock() failed\n");
840 return 1;
841 }
842 if (pthread_mutex_unlock(&mutex)) {
843 printf("pthread_mutex_unlock() failed\n");
844 return 1;
845 }
846 printf("found, OK.\n");
847}
848EOF
849 if test_compile $LIBPTHREAD pthread pthread; then
850 if test_execute; then
851 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
852 fi
853 fi
854}
855
856#
857# Check for zlib, needed by VBoxSVC, Runtime, ...
858#
859check_z()
860{
861 test_header zlib
862 cat > .tmp_src.cc << EOF
863#include <cstdio>
864#include <zlib.h>
865extern "C" int main(void)
866{
867 printf("found version %s", ZLIB_VERSION);
868#if ZLIB_VERNUM >= 0x1210
869 printf(", OK.\n");
870 return 0;
871#else
872 printf(", expected version 1.2.1 or higher\n");
873 return 1;
874#endif
875}
876EOF
877 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
878 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
879 if test_execute; then
880 cnf_append "SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
881 cnf_append "SDK_VBOX_ZLIB_INCS" "$INCZ"
882 fi
883 fi
884}
885
886#
887# Check for libpng, needed by kchmviewer
888#
889check_png()
890{
891 test_header libpng
892 cat > .tmp_src.cc << EOF
893#include <cstdio>
894#include <png.h>
895extern "C" int main(void)
896{
897 printf("found version %s", PNG_LIBPNG_VER_STRING);
898#if PNG_LIBPNG_VER >= 10205
899 printf(", OK.\n");
900 return 0;
901#else
902 printf(", expected version 1.2.5 or higher\n");
903 return 1;
904#endif
905}
906EOF
907 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
908# if test_compile "$LIBPNG $I_INCPNG" libpng libpng nofatal; then
909 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
910# if test_execute nofatal; then
911 if test_execute; then
912 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
913 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
914 fi
915 fi
916}
917
918#
919# Check for pam, needed by VRDPAuth
920# Version 79 was introduced in 9/2005, do we support older versions?
921# Debian/sarge uses 76
922# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
923#
924check_pam()
925{
926 test_header pam
927 cat > .tmp_src.cc << EOF
928#include <cstdio>
929#include <security/pam_appl.h>
930extern "C" int main(void)
931{
932 printf("found version %d", __LIBPAM_VERSION);
933 if (__LIBPAM_VERSION >= 76)
934 {
935 printf(", OK.\n");
936 return 0;
937 }
938 else
939 {
940 printf(", expected version 76 or higher\n");
941 return 1;
942 }
943}
944EOF
945 if test_compile "-lpam" pam pam nofatal; then
946 if test_execute nofatal; then
947 return 0;
948 fi
949 fi
950 test_header linux_pam
951 cat > .tmp_src.cc << EOF
952#include <cstdio>
953#include <security/pam_appl.h>
954extern "C" int main(void)
955{
956 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
957 if (__LINUX_PAM__ >= 1)
958 {
959 printf(", OK.\n");
960 return 0;
961 }
962 else
963 {
964 printf(", expected version 1.0 or higher\n");
965 return 1;
966 }
967}
968EOF
969 if test_compile "-lpam" pam pam; then
970 test_execute
971 fi
972}
973
974
975#
976# Check for the SDL library, needed by VBoxSDL and VirtualBox
977# We depend at least on version 1.2.7
978#
979check_sdl()
980{
981 test_header SDL
982 if [ "$OS" = "darwin" ]; then
983 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
984 PATH_SDK_LIBSDL="/System/Library/Framework/SDL.framework"
985 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
986 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
987 fi
988 if [ -n "$PATH_SDK_LIBSDL" ]; then
989 foundsdl=1
990 INCSDL="$PATH_SDK_LIBSDL/Headers"
991 FLDSDL="-framework SDL"
992 else
993 log_failure "SDL framework not found"
994 fail
995 fi
996 else
997 if which_wrapper sdl-config > /dev/null; then
998 FLGSDL=`sdl-config --cflags`
999 INCSDL=`strip_I "$FLGSDL"`
1000 LIBSDL=`sdl-config --libs`
1001 LIBSDLMAIN="-lSDLmain"
1002 FLDSDL=
1003 foundsdl=1
1004 fi
1005 fi
1006 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1007 if [ -n "$foundsdl" ]; then
1008 cat > .tmp_src.cc << EOF
1009#include <cstdio>
1010#include <SDL.h>
1011#include <SDL_main.h>
1012#undef main
1013extern "C" int main(int argc, char** argv)
1014{
1015 printf("found version %d.%d.%d",
1016 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1017#if SDL_VERSION_ATLEAST(1,2,7)
1018 printf(", OK.\n");
1019 return 0;
1020#else
1021 printf(", expected version 1.2.7 or higher\n");
1022 return 1;
1023#endif
1024}
1025EOF
1026 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1027 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1028 if test_execute; then
1029 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1030 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1031 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1032 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1033 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1034 fi
1035 fi
1036 else
1037 log_failure "not found"
1038 fail
1039 fi
1040}
1041
1042#
1043# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1044#
1045check_sdl_ttf()
1046{
1047 test_header SDL_ttf
1048 cat > .tmp_src.cc << EOF
1049#include <cstdio>
1050#include <SDL_ttf.h>
1051#ifndef SDL_TTF_MAJOR_VERSION
1052#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1053#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1054#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1055#endif
1056extern "C" int main(void)
1057{
1058 printf("found version %d.%d.%d",
1059 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1060#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1061 printf(", OK.\n");
1062 return 0;
1063#else
1064 printf(", expected version 2.0.6 or higher\n");
1065 return 1;
1066#endif
1067}
1068EOF
1069 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1070 if ! test_execute nofatal; then
1071 cnf_append "VBOX_WITH_SECURELABEL" ""
1072 fi
1073 else
1074 cnf_append "VBOX_WITH_SECURELABEL" ""
1075 fi
1076}
1077
1078#
1079# Check for libasound, needed by the ALSA audio backend
1080#
1081check_alsa()
1082{
1083 test_header ALSA
1084 cat > .tmp_src.cc << EOF
1085#include <cstdio>
1086#include <alsa/asoundlib.h>
1087extern "C" int main(void)
1088{
1089 printf("found version %d.%d.%d",
1090 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1091#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1092 printf(", OK.\n");
1093 return 0;
1094#else
1095 printf(", expected version 1.0.6 or higher\n");
1096 return 1;
1097#endif
1098}
1099EOF
1100 if test_compile "-lasound" asound asound; then
1101 test_execute
1102 fi
1103}
1104
1105#
1106# Check for PulseAudio
1107#
1108check_pulse()
1109{
1110 test_header "PulseAudio"
1111 cat > .tmp_src.cc << EOF
1112#include <cstdio>
1113#include <pulse/version.h>
1114extern "C" int main(void)
1115{
1116 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1117#if PA_API_VERSION >= 9
1118 printf(", OK.\n");
1119 return 0;
1120#else
1121 printf(", expected version 0.9.0 (API version 9) or higher\n");
1122 return 1;
1123#endif
1124}
1125EOF
1126 if test_compile "-lpulse" pulse pulse; then
1127 test_execute
1128 fi
1129}
1130
1131#
1132# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1133#
1134check_xcursor()
1135{
1136 test_header Xcursor
1137 cat > .tmp_src.cc << EOF
1138#include <cstdio>
1139#include <X11/Xlib.h>
1140#include <X11/Xcursor/Xcursor.h>
1141extern "C" int main(void)
1142{
1143 XcursorImage *cursor = XcursorImageCreate (10, 10);
1144 XcursorImageDestroy(cursor);
1145 return 0;
1146}
1147EOF
1148 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1149 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1150 log_success "found"
1151 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1152 fi
1153}
1154
1155#
1156# Check for the X libraries (Xext, X11)
1157#
1158check_x()
1159{
1160 test_header "X libraries"
1161 cat > .tmp_src.cc << EOF
1162#include <cstdio>
1163#include <X11/Xlib.h>
1164extern "C" int main(void)
1165{
1166 Display *dpy;
1167 int scrn_num;
1168 Screen *scrn;
1169 Window win;
1170
1171 dpy = XOpenDisplay(NULL);
1172 scrn_num = DefaultScreen(dpy);
1173 scrn = ScreenOfDisplay(dpy, scrn_num);
1174 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1175 0, 16, InputOutput, CopyFromParent, 0, NULL);
1176 XDestroyWindow(dpy, win);
1177}
1178EOF
1179 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1180 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1181 log_success "found"
1182 fi
1183}
1184
1185#
1186# Check for the Qt3 library, needed by VirtualBox
1187#
1188check_qt3()
1189{
1190 test_header Qt3
1191 cat > .tmp_src.cc << EOF
1192#include <cstdio>
1193#include <qglobal.h>
1194extern "C" int main(void)
1195{
1196 printf("found version %s", QT_VERSION_STR);
1197#if QT_VERSION >= 0x030305
1198 printf(", OK.\n");
1199 return 0;
1200#elif QT_VERSION >= 0x030300
1201 printf("\n ** WARNING: QT < 3.3.5 has known problems!\n");
1202#else
1203 printf(", expected version 3.3.0 or higher\n");
1204 return 1;
1205#endif
1206}
1207EOF
1208 found_qt=0
1209 libs="lib"
1210 [ "$LIB" = "lib64" ] && libs="$libs lib64"
1211 for q in $QT3DIR; do
1212 for l in $libs; do
1213 echo "compiling the following source file:" >> $LOG
1214 cat .tmp_src.cc >> $LOG
1215 echo "using the following command line:" >> $LOG
1216 echo "$CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt $LIBPTHREAD" >> $LOG
1217 $CXX -O -Wall -o .tmp_out .tmp_src.cc -I$q/include -L$q/$l -lqt-mt $LIBPTHREAD >> $LOG 2>&1
1218 if [ $? -eq 0 ]; then
1219 if test_execute; then
1220 cnf_append "QTDIR" "`cd $q ; pwd`"
1221 found_qt=1
1222 break
1223 fi
1224 fi
1225 done
1226 if [ $found_qt -eq 1 ]; then
1227 break
1228 fi
1229 done
1230 if [ $found_qt -ne 1 ]; then
1231 echo
1232 echo " Qt3 not found at \"$QT3DIR\" or Qt3 headers not found"
1233 echo " Check the file $LOG for detailed error information."
1234 fail
1235 return 1
1236 fi
1237 test_header "Qt3 devtools"
1238 if check_avail "$q/bin/moc" QT3DIR/bin; then
1239 moc_ver=`$q/bin/moc 2>&1 -v|sed 's+^.*(Qt \(.*\))+\1+'`
1240 if [ $? -ne 0 ]; then
1241 log_failure "not found"
1242 fail
1243 else
1244 log_success "found version $moc_ver"
1245 fi
1246 fi
1247}
1248
1249#
1250# Check for the Qt4 library, needed by VirtualBox4
1251#
1252# Currently not fatal.
1253#
1254check_qt4()
1255{
1256 test_header Qt4
1257 if [ "$OS" = "darwin" ]; then
1258 if [ -f "/System/Library/Frameworks/QtCore.framework/QtCore" ]; then
1259 PATH_SDK_QT4="/System/Library/Framework/QtCore.framework"
1260 elif [ -f "/Library/Frameworks/QtCore.framework/QtCore" ]; then
1261 PATH_SDK_QT4="/Library/Frameworks/QtCore.framework"
1262 fi
1263 if [ -n "$PATH_SDK_QT4" ]; then
1264 foundqt4=1
1265 INCQT4="$PATH_SDK_QT4/Headers"
1266 LIBQT4=
1267 FLGQT4="-framework QtCore"
1268 else
1269 log_failure "Qt4 framework not found"
1270 fail
1271 fi
1272 else
1273 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1274 # default is to use pkg-config
1275 if which_wrapper pkg-config > /dev/null; then
1276 # this braindead path is necessary for mdv2008.1
1277 qt4_ver=`\
1278 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1279 pkg-config QtCore --modversion 2>> $LOG`
1280 if [ $? -ne 0 ]; then
1281 log_failure "not found"
1282 fail
1283 else
1284 FLGQT4=`\
1285 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1286 pkg-config QtCore --cflags`
1287 INCQT4=`strip_I "$FLGQT4"`
1288 LIBQT4=`\
1289 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1290 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1291 pkg-config QtCore --libs`
1292 foundqt4=1
1293 fi
1294 else
1295 log_failure "pkg-config not found"
1296 fail
1297 fi
1298 else
1299 # do it the old way (e.g. user has specified QT4DIR)
1300 cat > .tmp_src.cc << EOF
1301#include <cstdio>
1302#include <QtGlobal>
1303extern "C" int main(void)
1304{
1305 printf("found version %s", QT_VERSION_STR);
1306#if QT_VERSION >= 0x040300
1307 printf(", OK.\n");
1308 return 0;
1309 printf(", expected version 4.3.0 or higher\n");
1310 return 1;
1311#endif
1312}
1313EOF
1314 for q in $QT4DIR; do
1315 INCQT4="$q/include $q/include/QtCore"
1316 FLGQT4="-DQT_SHARED"
1317 I_INCQT4=`prefix_I "$INCQT4"`
1318 LIBQT4="-L$q/lib -lVBoxQtCore"
1319 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1320 foundqt4=2
1321 break;
1322 fi
1323 LIBQT4="-L$q/lib -lQtCore"
1324 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1325 foundqt4=1
1326 break;
1327 fi
1328 done
1329 fi
1330 fi
1331 if [ -n "$foundqt4" ]; then
1332 cat > .tmp_src.cc << EOF
1333#include <cstdio>
1334#include <QtGlobal>
1335extern "C" int main(void)
1336{
1337 printf("found version %s", QT_VERSION_STR);
1338#if QT_VERSION >= 0x040300
1339 printf(", OK.\n");
1340 return 0;
1341 printf(", expected version 4.3.0 or higher\n");
1342 return 1;
1343#endif
1344}
1345EOF
1346 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1347 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1348 if test_execute_path "`strip_L "$LIBQT4"`"; then
1349 if [ "$OS" != "darwin" ]; then
1350 # strip .../QtCore as we add components ourself
1351 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1352 # store only the first path, remove all other pathes
1353 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1354 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1355 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1356 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1357 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1358 # this is not quite right since the qt libpath does not have to be first...
1359 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1360 if [ "$foundqt4" = "2" ]; then
1361 cnf_append "VBOX_WITH_QT4_SUN" "1"
1362 fi
1363 test_header "Qt4 devtools"
1364 for q in $QT4DIR; do
1365 if which_wrapper "$q/bin/moc" > /dev/null; then
1366 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1367 if [ $? -ne 0 ]; then
1368 log_failure "not found"
1369 fail
1370 else
1371 log_success "found version $moc_ver"
1372 cnf_append "VBOX_PATH_QT4" "$q"
1373 cnf_append "PATH_SDK_QT4" "$q"
1374 cnf_append "PATH_TOOL_QT4" "$q"
1375 return
1376 fi
1377 fi
1378 done
1379 fi
1380 fi
1381 else
1382 log_failure "not found"
1383 fail
1384 fi
1385 else
1386 log_failure "not found"
1387 fail
1388 fi
1389}
1390
1391
1392#
1393# Check whether static libstdc++ is installed
1394#
1395check_staticlibstdcxx()
1396{
1397 test_header "static stc++ library"
1398 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1399 cat > .tmp_src.cc << EOF
1400#include <string>
1401
1402extern "C" int main(void)
1403{
1404 std::string s = "test";
1405 return 0;
1406}
1407EOF
1408 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1409 log_success "found"
1410 fi
1411}
1412
1413#
1414# Check for Linux sources
1415#
1416check_linux()
1417{
1418 test_header "Linux kernel sources"
1419 cat > .tmp_src.c << EOF
1420#include <linux/version.h>
1421int printf(const char *format, ...);
1422int main(void)
1423{
1424 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1425 (LINUX_VERSION_CODE % 65536) / 256,
1426 LINUX_VERSION_CODE % 256);
1427#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1428 printf(", OK.\n");
1429 return 0;
1430#else
1431 printf(", expected version 2.4.0 or higher\n");
1432 return 1;
1433#endif
1434}
1435EOF
1436 echo "compiling the following source file:" >> $LOG
1437 cat .tmp_src.c >> $LOG
1438 echo "using the following command line:" >> $LOG
1439 echo "$CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1440 $CC -O -Wall -o .tmp_out .tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1441 if [ $? -ne 0 ]; then
1442 echo
1443 echo " Linux kernel headers not found at $LINUX"
1444 echo " Check the file $LOG for detailed error information."
1445 fail
1446 else
1447 if test_execute; then
1448 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1449 fi
1450 fi
1451}
1452
1453#
1454# Check for kchmviewer, needed to display the online help
1455#
1456check_kchmviewer()
1457{
1458 test_header kchmviewer
1459 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1460 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1461 if [ $? -ne 0 ]; then
1462 log_failure "not found"
1463 fail
1464 else
1465 log_success "found version $kchmviewer_ver"
1466 fi
1467 fi
1468}
1469
1470#
1471# Check for the kBuild tools, we don't support GNU make
1472#
1473check_kbuild()
1474{
1475 test_header kBuild
1476 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1477 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1478 echo "export PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1479 echo "export PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1480 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1481 echo "export PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1482 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1483 if [ "$OS" = "solaris" ]; then
1484 # Because of sh being non-default shell in Solaris we need to export PATH again when
1485 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1486 echo "PATH=\"$ORGPATH\"" >> $ENV
1487 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1488 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1489 else
1490 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1491 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1492 fi
1493 echo "export PATH" >> $ENV
1494 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1495 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1496 elif check_avail "kmk" KBUILDDIR really; then
1497 # check for installed kBuild
1498 KBUILD_SED="`which_wrapper kmk_sed`"
1499 else
1500 fail
1501 fi
1502 log_success "found"
1503}
1504
1505
1506#
1507# Check for compiler.h
1508# Some Linux distributions include "compiler.h" in their libc linux
1509# headers package, some don't. Most don't need it, building might (!)
1510# not succeed on openSUSE without it.
1511#
1512# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1513#
1514check_compiler_h()
1515{
1516 test_header compiler.h
1517 if ! test -f "/usr/include/linux/compiler.h"; then
1518 cnf_append "VBOX_WITHOUT_LINUX_COMPILER_H" "1"
1519 log_success "compiler.h not found"
1520 else
1521 log_success "compiler.h found"
1522 fi
1523}
1524
1525
1526#
1527# Check if we are able to build 32-bit applications (needed for the guest additions)
1528#
1529check_32bit()
1530{
1531 test_header "32-bit support"
1532 cat > .tmp_src.c << EOF
1533#include <stdint.h>
1534int main(void)
1535{
1536 return 0;
1537}
1538EOF
1539 echo "compiling the following source file:" >> $LOG
1540 cat .tmp_src.c >> $LOG
1541 echo "using the following command line:" >> $LOG
1542 echo "$CC -m32 -O -Wall -o .tmp_out .tmp_src.c" >> $LOG
1543 $CC -m32 -O -Wall -o .tmp_out .tmp_src.c >> $LOG 2>&1
1544 if [ $? -ne 0 ]; then
1545 echo
1546 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1547 echo " Check the file $LOG for detailed error information."
1548 fail
1549 fi
1550 log_success ""
1551}
1552
1553#
1554# Setup wine
1555#
1556setup_wine()
1557{
1558 test_header "Wine support"
1559 if ! which_wrapper wine > /dev/null; then
1560 echo " wine binary not found"
1561 fail
1562 fi
1563 if ! which_wrapper wineprefixcreate > /dev/null; then
1564 echo " wineprefixcreate not found"
1565 fail
1566 fi
1567 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1568 echo "export WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1569 rm -rf $WINEPREFIX
1570 mkdir -p $WINEPREFIX
1571 touch $WINEPREFIX/.no_prelaunch_window_flag
1572 if ! wineprefixcreate -q > /dev/null 2>&1; then
1573 echo " wineprefixcreate failed"
1574 fail
1575 fi
1576 tmp=.tmp.wine.reg
1577 rm -f $tmp
1578 echo 'REGEDIT4' > $tmp
1579 echo '' >> $tmp
1580 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1581 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1582 echo '' >> $tmp
1583 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1584 echo '"itss"="native"' >> $tmp
1585 echo '' >> $tmp
1586 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1587 echo '"itss"="native"' >> $tmp
1588 echo '' >> $tmp
1589 if ! wine regedit $tmp > /dev/null 2>&1; then
1590 rm -f $tmp
1591 echo " failed to load registry changes (path)."
1592 fail
1593 fi
1594 rm -f $tmp
1595 log_success "found"
1596}
1597
1598
1599#
1600# Determines the Darwin version.
1601# @todo This should really check the Xcode/SDK version.
1602#
1603check_darwinversion()
1604{
1605 test_header "Darwin version"
1606 darwin_ver=`uname -r`
1607 case "$darwin_ver" in
1608 9\.*)
1609 darwin_ver="10.5"
1610 #cnf_append "VBOX_TARGET_MAC_OS_X_VERSION_10_5" "1"
1611 ;;
1612 8\.*)
1613 darwin_ver="10.4"
1614 ;;
1615 *)
1616 echo " failed to determin darwin version. (uname -r: $darwin_ver)"
1617 fail
1618 darwin_ver="unknown"
1619 ;;
1620 esac
1621 log_success "found version $darwin_ver"
1622}
1623
1624
1625#
1626# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
1627# is around to prevent confusion when the build fails in src/recompiler.
1628# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
1629#
1630check_i386elfgcc()
1631{
1632 test_header "i386-elf-gcc"
1633 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
1634 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
1635 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
1636 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
1637 if test -z "$i386_elf_gcc"; then
1638 echo " failed to find i386-elf-gcc"
1639 fail
1640 fi
1641 log_success "found $i386_elf_gcc"
1642}
1643
1644
1645#
1646# Show help
1647#
1648show_help()
1649{
1650 cat << EOF
1651Usage: ./configure [OPTIONS]...
1652
1653Configuration:
1654 -h, --help display this help and exit
1655 --nofatal don't abort on errors
1656 --disable-xpcom disable XPCOM and related stuff
1657 --disable-sdl-ttf disable SDL_ttf detection
1658 --disable-alsa disable the ALSA sound backend
1659 --disable-pulse disable the PulseAudio backend
1660 --disable-kmods don't build Linux kernel modules (host and guest)
1661 --build-libxml2 build libxml2 from sources
1662 --build-libxslt build libxslt from sources
1663 --setup-wine setup a Wine directory and register the hhc hack
1664
1665Paths:
1666 --with-gcc=PATH location of the gcc compiler [$CC]
1667 --with-g++=PATH location of the g++ compiler [$CXX]
1668 --with-gcc-compat=PATH location of the gcc compiler for recompiler [$CC]
1669 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
1670 --with-iasl=PATH location of the iasl compiler [$IASL]
1671 --with-linux=DIR Linux kernel source directory [$LINUX]
1672 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
1673 --with-qt-dir=DIR directory for Qt3 headers/libraries [$QT3DIR]
1674 --with-qt4-dir=DIR directory for Qt4 headers/libraries [pkgconfig]
1675
1676Build type:
1677 -d, --build-debug build with debugging symbols and assertions
1678 --build-profile build with profiling support
1679 --build-headless build headless (without any X11 frontend)
1680EOF
1681 exit 0
1682}
1683
1684
1685#
1686# The body.
1687#
1688
1689# scan command line options
1690for option in $*; do
1691 case "$option" in
1692 --help|-help|-h)
1693 show_help
1694 ;;
1695 --nofatal)
1696 nofatal=1
1697 ;;
1698 --env-only)
1699 ENV_ONLY=1
1700 ;;
1701 --with-gcc=*)
1702 CC=`echo $option | cut -d'=' -f2`
1703 ;;
1704 --with-g++=*)
1705 CXX=`echo $option | cut -d'=' -f2`
1706 ;;
1707 --with-gcc-compat=*)
1708 CC_COMPAT=`echo $option | cut -d'=' -f2`
1709 ;;
1710 --with-kbuild=*)
1711 KBUILDDIR=`echo $option | cut -d'=' -f2`
1712 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
1713 echo "Error: KBUILDDIR contains invalid characters!"
1714 exit 1
1715 fi
1716 ;;
1717 --with-qt-dir=*)
1718 QT3DIR=`echo $option | cut -d'=' -f2`
1719 ;;
1720 --with-qt4-dir=*)
1721 QT4DIR=`echo $option | cut -d'=' -f2`
1722 QT4DIR_PKGCONFIG=0
1723 ;;
1724 --with-iasl=*)
1725 IASL=`echo $option | cut -d'=' -f2`
1726 ;;
1727 --with-linux=*)
1728 LINUX=`echo $option | cut -d'=' -f2`
1729 ;;
1730 --with-mkisofs=*)
1731 MKISOFS=`echo $option | cut -d'=' -f2`
1732 ;;
1733 --disable-xpcom)
1734 WITH_XPCOM=0
1735 ;;
1736 --disable-sdl-ttf)
1737 WITH_SDL_TTF=0
1738 ;;
1739 --disable-qt)
1740 WITH_QT3=0
1741 WITH_QT4=0
1742 ;;
1743 --disable-qt3)
1744 WITH_QT3=0
1745 ;;
1746 --disable-qt4)
1747 WITH_QT4=0
1748 ;;
1749 --disable-alsa)
1750 WITH_ALSA=0
1751 ;;
1752 --disable-pulse)
1753 WITH_PULSE=0
1754 ;;
1755 --disable-kmods)
1756 WITH_KMODS=0
1757 ;;
1758 --build-debug|-d)
1759 BUILD_TYPE=debug
1760 ;;
1761 --build-profile)
1762 BUILD_TYPE=profile
1763 ;;
1764 --build-libxml2)
1765 BUILD_LIBXML2=1
1766 ;;
1767 --build-libxslt)
1768 BUILD_LIBXSLT=1
1769 ;;
1770 --build-headless)
1771 HEADLESS=1
1772 WITH_SDL=0
1773 WITH_SDL_TTF=0
1774 WITH_X11=0
1775 WITH_QT3=0
1776 WITH_QT4=0
1777 ;;
1778 --ose)
1779 OSE=2
1780 ;;
1781 --odir=*)
1782 ODIR="`echo $option | cut -d'=' -f2`/"
1783 ;;
1784 --setup-wine)
1785 SETUP_WINE=1
1786 ;;
1787 *)
1788 echo
1789 echo "Unrecognized option \"$option\""
1790 echo
1791 show_help
1792 ;;
1793 esac
1794done
1795
1796LOG="$ODIR$LOG"
1797ENV="$ODIR$ENV"
1798CNF="$ODIR$CNF"
1799
1800# initialize output files
1801cat > $LOG << EOF
1802# Log file generated by
1803#
1804# '$0 $*'
1805#
1806
1807EOF
1808cat > $CNF << EOF
1809# -*- Makefile -*-
1810#
1811# automatically generated by
1812#
1813# '$0 $*'
1814#
1815# It will be completely overwritten if configure is executed again.
1816#
1817
1818EOF
1819cat > $ENV << EOF
1820#!/bin/bash
1821#
1822# automatically generated by
1823#
1824# '$0 $*'
1825#
1826# It will be completely overwritten if configure is executed again.
1827# Make sure you source this file once before you start to build VBox.
1828#
1829
1830EOF
1831
1832# test if we are OSE
1833if [ $OSE -eq 1 -a -d "`cd \`dirname $0\`; pwd`/src/VBox/Devices/USB" ]; then
1834 echo "Found USB devices, assuming VBOX_OSE = FALSE" >> $LOG
1835 echo >> $LOG
1836 OSE=0
1837fi
1838
1839if [ "$BUILD_TYPE" = "debug" ]; then
1840 echo "Creating DEBUG build!" >> $LOG
1841elif [ "$BUILD_TYPE" = "profile" ]; then
1842 echo "Creating PROFILE build!" >> $LOG
1843fi
1844
1845# first determine our environment
1846check_environment
1847check_kbuild
1848
1849[ -n "$ENV_ONLY" ] && exit 0
1850
1851# append the tools directory to the default search path
1852echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
1853export PATH
1854
1855# some things are not available in for OSE
1856if [ $OSE -ge 1 ]; then
1857 cnf_append "VBOX_OSE" "1"
1858 cnf_append "VBOX_WITH_TESTSUITE" ""
1859 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
1860
1861 if [ "$OS" = "linux" ]; then
1862 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
1863 else
1864 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
1865 fi
1866 echo >> $CNF
1867fi
1868
1869# headless
1870if [ -n "$HEADLESS" ]; then
1871 cnf_append "VBOX_HEADLESS" "1"
1872fi
1873
1874if [ "$OS" = "darwin" ]; then
1875 # On Darwin we want to build against Qt4 only. WITH_QT4 is enabled by
1876 # default so disable Qt3. --disable-qt disables both Qt3 and Qt4 GUI now,
1877 # --disable-qt4 disables only the Qt4 GUI (which is not appropriate for
1878 # Darwin as we disable the Qt3 here anyway.
1879 # (Qt3 builds for Intel Macs are usually not threaded or for X11. And they
1880 # don't contain our patches, which means the result isn't really usable.)
1881 WITH_QT3=0
1882 # No Qt4 for OSE yet.
1883 [ $OSE -ge 1 ] && WITH_QT4=0
1884 BUILD_LIBXSLT=1
1885 BUILD_LIBXML2=1
1886fi
1887
1888# emit disable directives corresponding to any --disable-xxx options.
1889[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
1890[ $WITH_QT3 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
1891[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QT4GUI" ""
1892[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
1893
1894# the tools
1895check_gcc
1896[ "$OS" != "darwin" ] && check_as86
1897[ "$OS" != "darwin" ] && check_bcc
1898[ "$OS" != "darwin" ] && check_iasl
1899# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
1900# [ "$OS" != "darwin" ] && check_yasm
1901[ "$OS" != "darwin" ] && check_xsltproc
1902[ $OSE -eq 0 -a "$OS" != "darwin" ] && check_mkisofs
1903
1904# the libraries
1905[ "$OS" != "darwin" ] && check_pthread
1906[ $WITH_XPCOM -eq 1 ] && check_libxml2
1907[ $WITH_XPCOM -eq 1 ] && check_libxslt
1908[ $WITH_LIBIDL -eq 1 ] && check_libidl
1909# build openssl on Darwin in every case
1910[ "$OS" != "darwin" -a $OSE -eq 0 ] && check_ssl
1911[ "$OS" != "darwin" ] && check_z
1912[ "$OS" != "darwin" ] && check_png
1913[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
1914[ $WITH_SDL -eq 1 ] && check_sdl
1915[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
1916[ $WITH_X11 -eq 1 ] && check_x
1917[ $WITH_X11 -eq 1 ] && check_xcursor
1918[ $WITH_QT3 -eq 1 ] && check_qt3
1919[ $WITH_QT4 -eq 1 ] && check_qt4
1920
1921# Linux-specific
1922if [ "$OS" = "linux" ]; then
1923 check_staticlibstdcxx
1924 if [ $WITH_KMODS -eq 1 ]; then
1925 check_linux
1926 else
1927 cnf_append "VBOX_LINUX_SRC" ""
1928 cnf_append "VBOX_WITH_VBOXDRV" ""
1929 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
1930 fi
1931 if [ $WITH_ALSA -eq 1 ]; then
1932 check_alsa
1933 else
1934 cnf_append "VBOX_WITH_ALSA" ""
1935 fi
1936 if [ $WITH_PULSE -eq 1 ]; then
1937 check_pulse
1938 else
1939 cnf_append "VBOX_WITH_PULSE" ""
1940 fi
1941 check_compiler_h
1942 [ "$BUILD_MACHINE" = "amd64" ] && check_32bit
1943fi
1944
1945[ -n "$SETUP_WINE" ] && setup_wine
1946
1947# Darwin-specific
1948if [ "$OS" = "darwin" ]; then
1949 check_darwinversion
1950 check_i386elfgcc
1951fi
1952
1953# success!
1954echo
1955echo "Successfully generated '$CNF' and '$ENV'."
1956echo "Source '$ENV' once before you start to build VBox:"
1957echo ""
1958echo " source $ENV"
1959echo " kmk"
1960echo ""
1961if [ "$OS" = "linux" ]; then
1962 echo "To compile the kernel module, do:"
1963 echo ""
1964 echo " cd ./out/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
1965 echo " make"
1966 echo ""
1967fi
1968echo "Enjoy!"
1969cleanup
Note: See TracBrowser for help on using the repository browser.

© 2024 Oracle Support Privacy / Do Not Sell My Info Terms of Use Trademark Policy Automated Access Etiquette